#ifndef __STC8G_EEPROM_H__
#define __STC8G_EEPROM_H__

#include  "typedef.h"
#include  "IOT.H"
#include  "UART.h "

/*
#define CMD_IDLE    0               //ģʽ
#define CMD_READ    1               //IAPֽڶ
#define CMD_PROGRAM 2               //IAPֽڱ
#define CMD_ERASE   3               //IAP
#define ENABLE_IAP 0x80             //ʹEEPROM
*/

#define  RUN_address 0x0000			//WAN洢ַ
#define	 Save_flag   0x39			//洢Ч־


#define IAP_EN          (1<<7)
#define IAP_SWBS        (1<<6)
#define IAP_SWRST       (1<<5)
#define IAP_CMD_FAIL    (1<<4)

#define	IAP_ENABLE()		IAP_CONTR = IAP_EN; IAP_TPS = FOSC / 1000000
#define	IAP_DISABLE()		IAP_CONTR = 0; IAP_CMD = 0; IAP_TRIG = 0; IAP_ADDRH = 0xff; IAP_ADDRL = 0xff


//sfr IAP_CMD   = 0xC5;
#define		IAP_STANDBY()	IAP_CMD = 0		//IAPֹ
#define		IAP_READ()		IAP_CMD = 1		//IAP
#define		IAP_WRITE()		IAP_CMD = 2		//IAPд
#define		IAP_ERASE()		IAP_CMD = 3		//IAP

//sfr IAP_TRIG  = 0xC6;
#define 	IAP_TRIG()	IAP_TRIG = 0x5A,	IAP_TRIG = 0xA5		/* IAP */

//							            7    6    5      4    3   2  1   0   Reset Value
//sfr IAP_CONTR = 0xC7;		IAPEN SWBS SWRST CFAIL  -   -  -   -   0000,x000	//IAP Control Register


typedef struct
{ 
	uchar 	EEPROM_flag;			//洢־
	int		count;					//д
	uchar	ver;					//а汾
	uint    password;			// 
} idata RUN_conf;

extern RUN_conf  RUN;





//========================================================================
//                              
//========================================================================

#define		STC8X1K08	8
#define		STC8X1K16	16
#define		STC8XxK32	32
#define		STC8XxK60	60

//	ѡMCUͺ
#define	MCU_Type	STC8X1K08  //STC8X1K08, STC8X1K16, STC8XxK32, STC8XxK32, STC8XxK60

/************************** ISP/IAP *****************************

   ͺ    С    ʼַ    ַ   MOVCƫƵַ
STC8X1K08   4K   8   0x0000  ~  0x0FFF       0x2000
STC8X1K16  12K   24  0x0000  ~  0x2FFF       0x4000
STC8XxK32  32K   64  0x0000  ~  0x7FFF       0x8000
STC8XxK60   4K   8   0x0000  ~  0x0FFF       0xF000

*/

#if   (MCU_Type == STC8X1K08)
      #define   MOVC_ShiftAddress    0x2000
#elif (MCU_Type == STC8X1K16)
      #define   MOVC_ShiftAddress    0x4000
#elif (MCU_Type == STC8XxK32)
      #define   MOVC_ShiftAddress    0x8000
#elif (MCU_Type == STC8XxK60)
      #define   MOVC_ShiftAddress    0xF000
#else
      #define   MOVC_ShiftAddress    0xC000		//ûԶ
#endif


void	DisableEEPROM(void);
void 	EEPROM_read_n(uint EE_address, uchar *DataAddress, uint number);
void 	EEPROM_write_n(uint EE_address, uchar *DataAddress, uint number);
void	EEPROM_SectorErase(uint EE_address);

void 	EEPROM_init();


#endif



